## mapnik 3.0.24+ds

=== SConstruct ===
# This file is part of Mapnik (c++ mapping toolkit)
#
# Copyright (C) 2017 Artem Pavlenko
#
# Mapnik is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from __future__ import print_function # support python2

import os
import sys
import re
import platform
from glob import glob
from copy import copy
from subprocess import Popen, PIPE
from SCons.SConf import SetCacheMode
import pickle

try:
    import distutils.sysconfig
    HAS_DISTUTILS = True
except:
    HAS_DISTUTILS = False

LIBDIR_SCHEMA_DEFAULT='lib'
severities = ['debug', 'warn', 'error', 'none']

ICU_INCLUDES_DEFAULT='/usr/include'
ICU_LIBS_DEFAULT='/usr/'

DEFAULT_CC = "cc"
DEFAULT_CXX = "c++"
DEFAULT_CXX11_CXXFLAGS = " -std=c++11 -DU_USING_ICU_NAMESPACE=0"
DEFAULT_CXX11_LINKFLAGS = ""
if sys.platform == 'darwin':
    # homebrew default
    ICU_INCLUDES_DEFAULT='/usr/local/opt/icu4c/include/'
    ICU_LIBS_DEFAULT='/usr/local/opt/icu4c/'

py3 = None

# local file to hold custom user configuration variables
# Todo check timestamp, reload if changed?
SCONS_LOCAL_CONFIG = 'config.py'
# build log
SCONS_LOCAL_LOG = 'config.log'
# local pickled file to cache configured environment
SCONS_CONFIGURE_CACHE = 'config.cache'
# directory SCons uses to stash build tests
SCONF_TEMP_DIR = '.sconf_temp'
# auto-search directories for boost libs/headers
BOOST_SEARCH_PREFIXES = ['/usr/local','/opt/local','/sw','/usr',]
BOOST_MIN_VERSION = '1.47'
#CAIRO_MIN_VERSION = '1.8.0'

HARFBUZZ_MIN_VERSION = (0, 9, 34)
HARFBUZZ_MIN_VERSION_STRING = "%s.%s.%s" % HARFBUZZ_MIN_VERSION


DEFAULT_LINK_PRIORITY = ['internal','other','frameworks','user','system']


pretty_dep_names = {
    'clntsh':'Oracle database library | configure with OCCI_LIBS & OCCI_INCLUDES | more info: https://github.com/mapnik/mapnik/wiki/OCCI',
    'gdal':'GDAL C++ library | configured using gdal-config program | try setting GDAL_CONFIG SCons option | more info: https://github.com/mapnik/mapnik/wiki/GDAL',
    'ogr':'OGR-enabled GDAL C++ Library | configured using gdal-config program | try setting GDAL_CONFIG SCons option | more info: https://github.com/mapnik/mapnik/wiki/OGR',
    'cairo':'Cairo C library | configured using pkg-config | try setting PKG_CONFIG_PATH SCons option',
    'proj':'Proj.4 C Projections library | configure with PROJ_LIBS & PROJ_INCLUDES | more info: http://trac.osgeo.org/proj/',
    'pg':'Postgres C Library required for PostGIS plugin | configure with pg_config program or configure with PG_LIBS & PG_INCLUDES | more info: https://github.com/mapnik/mapnik/wiki/PostGIS',
    'sqlite3':'SQLite3 C Library | configure with SQLITE_LIBS & SQLITE_INCLUDES | more info: https://github.com/mapnik/mapnik/wiki/SQLite',
    'jpeg':'JPEG C library | configure with JPEG_LIBS & JPEG_INCLUDES',
    'tiff':'TIFF C library | configure with TIFF_LIBS & TIFF_INCLUDES',
    'png':'PNG C library | configure with PNG_LIBS & PNG_INCLUDES',
    'webp':'WEBP C library | configure with WEBP_LIBS & WEBP_INCLUDES',
    'icuuc':'ICU C++ library | configure with ICU_LIBS & ICU_INCLUDES or use ICU_LIB_NAME to specify custom lib name  | more info: http://site.icu-project.org/',
    'harfbuzz':'HarfBuzz text shaping library | configure with HB_LIBS & HB_INCLUDES',
    'harfbuzz-min-version':'HarfBuzz >= %s (required for font-feature-settings support)' % HARFBUZZ_MIN_VERSION_STRING,
    'z':'Z compression library | more info: http://www.zlib.net/',
    'm':'Basic math library, part of C++ stlib',
    'pkg-config':'pkg-config tool | more info: http://pkg-config.freedesktop.org',
    'pg_config':'pg_config program | try setting PG_CONFIG SCons option',
    'pq':'libpq library (postgres client) | try setting PG_CONFIG SCons option or configure with PG_LIBS & PG_INCLUDES',
    'xml2-config':'xml2-config program | try setting XML2_CONFIG SCons option or avoid the need for xml2-config command by configuring with XML2_LIBS & XML2_INCLUDES',
    'libxml2':'libxml2 library | try setting XML2_CONFIG SCons option to point to location of xml2-config program or configure with XML2_LIBS & XML2_INCLUDES',
    'gdal-config':'gdal-config program | try setting GDAL_CONFIG SCons option',
    'freetype-config':'freetype-config program | try setting FREETYPE_CONFIG SCons option or configure with FREETYPE_LIBS & FREETYPE_INCLUDES',
    'freetype':'libfreetype library | try setting FREETYPE_CONFIG SCons option or configure with FREETYPE_LIBS & FREETYPE_INCLUDES',
    'osm':'more info: https://github.com/mapnik/mapnik/wiki/OsmPlugin',
    'boost_regex_icu':'libboost_regex built with optional ICU unicode support is needed for unicode regex support in mapnik.',
    'sqlite_rtree':'The SQLite plugin requires libsqlite3 built with RTREE support (-DSQLITE_ENABLE_RTREE=1)',
    'pgsql2sqlite_rtree':'The pgsql2sqlite program requires libsqlite3 built with RTREE support (-DSQLITE_ENABLE_RTREE=1)',
    'PROJ_LIB':'The directory where proj4 stores its data files. Must exist for proj4 to work correctly',
    'GDAL_DATA':'The directory where GDAL stores its data files. Must exist for GDAL to work correctly',
    'ICU_DATA':'The directory where icu stores its data files. If ICU reports a path, it must exist. ICU can also be built without .dat files and in that case this path is empty'
    }

# Core plugin build configuration
# opts.AddVariables still hardcoded however...
PLUGINS = { # plugins with external dependencies
            # configured by calling project, hence 'path':None
            'postgis': {'default':True,'path':None,'inc':'libpq-fe.h','lib':'pq','lang':'C'},
            'pgraster': {'default':True,'path':None,'inc':'libpq-fe.h','lib':'pq','lang':'C'},
            'gdal':    {'default':True,'path':None,'inc':'gdal_priv.h','lib':'gdal','lang':'C++'},
            'ogr':     {'default':True,'path':None,'inc':'ogrsf_frmts.h','lib':'gdal','lang':'C++'},
            'sqlite':  {'default':True,'path':'SQLITE','inc':'sqlite3.h','lib':'sqlite3','lang':'C'},
            # plugins without external dependencies requiring CheckLibWithHeader...
            'shape':   {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'csv':     {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'raster':  {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'geojson': {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'topojson':{'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'}
            }


def init_environment(env):
    env.Decider('MD5-timestamp')
    env.SourceCode(".", None)
    if os.environ.get('RANLIB'):
        env['RANLIB'] = os.environ['RANLIB']
    if os.environ.get('AR'):
        env['AR'] = os.environ['AR']

#### SCons build options and initial setup ####
env = Environment(ENV=os.environ)
init_environment(env)

def fix_path(path):
    return str(os.path.abspath(path))

def color_print(color,text,newline=True):
    # 1 - red
    # 2 - green
    # 3 - yellow
    # 4 - blue
    text = "\033[9%sm%s\033[0m" % (color,text)
    if not newline:
        print (text, end='')
    else:
        print (text)

def regular_print(color,text,newline=True):
    if not newline:
        print (text, end='')
    else:
        print (text)

def call(cmd, silent=False):
    stdin, stderr = Popen(cmd, shell=True, stdout=PIPE, stderr=PIPE).communicate()
    if not stderr:
        return stdin.strip()
    elif not silent:
        color_print(1,'Problem encounted with SCons scripts, please post bug report to: https://github.com/mapnik/mapnik/issues \nError was: %s' % stderr)

def strip_first(string,find,replace=''):
    if string.startswith(find):
        return string.replace(find,replace,1)
    return string

# http://www.scons.org/wiki/InstallTargets
def create_uninstall_target(env, path, is_glob=False):
    if 'uninstall' in COMMAND_LINE_TARGETS:
        if is_glob:
            all_files = Glob(path,strings=True)
            for filei in all_files:
                env.Command( "uninstall-"+filei, filei,
                [
                Delete("$SOURCE"),
                ])
                env.Alias("uninstall", "uninstall-"+filei)
        else:
            if os.path.exists(path):
                env.Command( "uninstall-"+path, path,
                [
                Delete("$SOURCE"),
                ])
                env.Alias("uninstall", "uninstall-"+path)

def shortest_name(libs):
    name = '-'*200
    for lib in libs:
        if len(name) > len(lib):
            name = lib
    return name

def rm_path(item,set,_env):
    for i in _env[set]:
        if i.startswith(item):
            _env[set].remove(i)

def sort_paths(items,priority):
    """Sort paths such that compiling and linking will globally prefer custom or local libs
    over system libraries by fixing up the order libs are passed to the compiler and the linker.

    Ideally preference could be by-target instead of global, but our SCons implementation
    is not currently utilizing different SCons build env()'s as we should.

    Overally the current approach within these scripts is to prepend paths of preference
    and append all others, but this does not give enough control (particularly due to the
    approach of assuming /usr/LIBSCHEMA and letting paths be parsed and added by pkg-config).

    In effect /usr/lib is likely to come before /usr/local/lib which makes linking against
    custom built icu or boost impossible when those libraries are available in both places.

    Sorting using a priority list allows this to be controlled, and fine tuned.
    """

    new = []
    path_types = {'internal':[],'other':[],'frameworks':[],'user':[],'system':[]}
    # parse types of paths into logical/meaningful groups
    # based on commonly encountered lib directories on linux and osx
    for i in items:
        # internal paths for code kept inside
        # the mapnik sources
        if i.startswith('#'):
            path_types['internal'].append(i)
        # Mac OS X user installed frameworks
        elif '/Library/Frameworks' in i:
            path_types['frameworks'].append(i)
        # various 'local' installs like /usr/local or /opt/local
        elif 'local' in i or '/sw' in i:
            if '/usr/local' in i:
                path_types['user'].insert(0,i)
            else:
                path_types['user'].append(i)
        # key system libs (likely others will fall into 'other')
        elif '/usr/' in i or '/System' in i or i.startswith('/lib'):
            path_types['system'].append(i)
        # anything not yet matched...
        # likely a combo of rare system lib paths and
        # very custom user paths that should ideally be
        # in 'user'
        else:
            path_types['other'].append(i)
    # build up new list based on priority list
    for path in priority:
        if path in path_types:
            dirs = path_types[path]
            new.extend(dirs)
            path_types.pop(path)
        else:
            color_print(1,'\nSorry, "%s" is NOT a valid value for option "LINK_PRIORITY": values include: %s' % (path,','.join(path_types.keys())))
            color_print(1,'\tinternal: the local directory of the Mapnik sources (prefix #) (eg. used to link internal agg)')
            color_print(1,'\tframeworks: on osx the /Library/Frameworks directory')

=== debian/changelog ===
mapnik (3.0.24+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright file.
  * Drop patches applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 05 Jan 2021 14:55:39 +0100

mapnik (3.0.23+ds-3) unstable; urgency=medium

  * Bump Standards-Version to 4.5.1, no changes.
  * Add upstream patch for Boost 1.73 compatibility.
    (closes: #975593)

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 12 Dec 2020 13:05:32 +0100

=== debian/control ===
Source: mapnik
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: David Paleino <dapal@debian.org>,
           Francesco Paolo Lovergine <frankie@debian.org>,
           Jérémy Lal <kapouer@melix.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 10~),
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcairo-dev,
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libfreetype6-dev,
               libgdal-dev,
               libharfbuzz-dev,
               libicu-dev,
               libjpeg-dev,
               libmapbox-variant-dev (>= 1.1.5),
               libpng-dev,
               libpq-dev,
               libproj-dev,
               libsqlite3-dev,
               libtiff-dev,
               libtool,
               libwebp-dev,
               libxml2-dev,
               pkg-config,
               python3,
               zlib1g-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/debian-gis-team/mapnik
Vcs-Git: https://salsa.debian.org/debian-gis-team/mapnik.git
Homepage: http://www.mapnik.org/

Package: libmapnik3.0
Architecture: any-amd64 i386 arm64 armel armhf powerpc ppc64el s390x alpha hppa m68k powerpcspe ppc64 sh4 sparc64 x32
Depends: fonts-dejavu,
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: postgis
Description: C++ toolkit for developing GIS applications (libraries)
 Mapnik is an OpenSource C++ toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 This package contains the shared library and input plugins.

Package: libmapnik-dev
Architecture: any-amd64 i386 arm64 armel armhf powerpc ppc64el s390x alpha hppa m68k powerpcspe ppc64 sh4 sparc64 x32
Section: libdevel
Depends: libmapnik3.0 (= ${binary:Version}),
         libboost-filesystem-dev,
         libboost-program-options-dev,
         libboost-regex-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libc6-dev | libc-dev,
         libcairo2-dev,
         libcurl4-gnutls-dev | libcurl-ssl-dev,
         libfreetype6-dev,
         libgdal-dev,
         libharfbuzz-dev,
         libicu-dev,
         libjpeg-dev,
         libmapbox-variant-dev (>= 1.1.5),
         libpng-dev,
         libpq-dev,
         libproj-dev,
         libsqlite3-dev,
         libtiff-dev,
         libwebp-dev,
         libxml2-dev,
         pkg-config,
         zlib1g-dev,
         ${misc:Depends}
Recommends: mapnik-doc
Breaks: libmapnik2-dev (<< 2.2.0+ds1-1~)
Replaces: libmapnik2-dev (<< 2.2.0+ds1-1~)
Description: C++ toolkit for developing GIS applications (devel)
 Mapnik is an OpenSource C++ toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 This package contains the development headers, API documentation, and
 build utilities.

Package: mapnik-utils
Architecture: any-amd64 i386 arm64 armel armhf powerpc ppc64el s390x alpha hppa m68k powerpcspe ppc64 sh4 sparc64 x32
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ toolkit for developing GIS applications (utilities)
 Mapnik is an OpenSource C++ toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 This package contains miscellaneous utilities distributed with mapnik:
 .
 shapeindex: program to creates file system based index for ESRI shape-files

Package: mapnik-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: libmapnik-dev
Description: C++ toolkit for developing GIS applications (doc)
 Mapnik is an OpenSource C++ toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 This package contains developer documentation.

## mapnik 3.1.0+ds

=== Makefile ===

OS := $(shell uname -s)

PYTHON = python

ifeq ($(JOBS),)
	JOBS:=1
endif

ifeq ($(HEAVY_JOBS),)
	HEAVY_JOBS:=1
endif

all: mapnik

install:
	$(PYTHON) scons/scons.py -j$(JOBS) --config=cache --implicit-cache --max-drift=1 install

release:
	./scripts/publish_release.sh

test-release:
	./scripts/test_release.sh

python:
	if [ ! -d ./bindings/python ]; then git clone git@github.com:mapnik/python-mapnik.git --recursive ./bindings/python; else (cd bindings/python && git pull && git submodule update --init); fi;
	make
	python bindings/python/test/visual.py -q

src/json/libmapnik-json.a:
	# we first build memory intensive files with -j$(HEAVY_JOBS)
	$(PYTHON) scons/scons.py -j$(HEAVY_JOBS) \
		--config=cache --implicit-cache --max-drift=1 \
		src/renderer_common/render_group_symbolizer.os \
		src/renderer_common/render_markers_symbolizer.os \
		src/renderer_common/render_thunk_extractor.os \
		src/json/libmapnik-json.a \
		src/wkt/libmapnik-wkt.a \
		src/css_color_grammar.os \
		src/expression_grammar.os \
		src/transform_expression_grammar.os \
		src/image_filter_grammar.os \
		src/marker_helpers.os \
		src/svg/svg_transform_parser.os \
		src/agg/process_line_symbolizer.os \
		plugins/input/geojson/geojson_datasource.os \
		utils/mapnik-index/process_geojson_file.o \
		src/svg/svg_path_parser.os \
		src/svg/svg_parser.os \
		src/svg/svg_points_parser.os \
		src/svg/svg_transform_parser.os \


mapnik: src/json/libmapnik-json.a
	# then install the rest with -j$(JOBS)
	$(PYTHON) scons/scons.py -j$(JOBS) --config=cache --implicit-cache --max-drift=1

clean:
	@$(PYTHON) scons/scons.py -j$(JOBS) -c --config=cache --implicit-cache --max-drift=1
	@if test -e ".sconsign.dblite"; then rm ".sconsign.dblite"; fi
	@if test -e "config.log"; then rm "config.log"; fi
	@if test -e "config.cache"; then rm "config.cache"; fi
	@if test -e ".sconf_temp/"; then rm -r ".sconf_temp/"; fi
	@find ./ -name "*.pyc" -exec rm {} \;
	@find ./ -name "*.os" -exec rm {} \;
	@find ./src/ -name "*.dylib" -exec rm {} \;
	@find ./src/ -name "*.so" -exec rm {} \;
	@find ./ -name "*.o" -exec rm {} \;
	@find ./src/ -name "*.a" -exec rm {} \;
	@find ./ -name "*.gcda" -exec rm {} \;
	@find ./ -name "*.gcno" -exec rm {} \;

distclean:
	if test -e "config.py"; then mv "config.py" "config.py.backup"; fi

reset: distclean

rebuild:
	make uninstall && make clean && time make && make install

uninstall:
	@$(PYTHON) scons/scons.py -j$(JOBS) --config=cache --implicit-cache --max-drift=1 uninstall

test/data-visual:
	./scripts/ensure_test_data.sh

test/data:
	./scripts/ensure_test_data.sh

test: ./test/data test/data-visual
	@./test/run

check: test

bench:
	./benchmark/run

demo:
	cd demo/c++; ./rundemo `mapnik-config --prefix`

pep8:
	# https://gist.github.com/1903033
	# gsed on osx
	@pep8 -r --select=W293 -q --filename=*.py `pwd`/tests/ | xargs gsed -i 's/^[ \r\t]*$$//'
	@pep8 -r --select=W391 -q --filename=*.py `pwd`/tests/ | xargs gsed -i -e :a -e '/^\n*$$/{$$d;N;ba' -e '}'
	@pep8 -r --select=W391 -q --filename=*.py `pwd`/tests/ | xargs ged -i '/./,/^$$/!d'

# note: pass --gen-suppressions=yes to create new suppression entries
grind:
	@source localize.sh && \
	    valgrind --suppressions=./test/unit/valgrind.supp --leak-check=full --log-fd=1 ./test/visual/run | grep definitely;
	@source localize.sh && \
	for FILE in test/standalone/*-bin; do \
		valgrind --suppressions=./test/unit/valgrind.supp --leak-check=full --log-fd=1 $${FILE} | grep definitely; \
	done
	@source localize.sh && \
	    valgrind --suppressions=./test/unit/valgrind.supp --leak-check=full --log-fd=1 ./test/unit/run | grep definitely;

render:
	@for FILE in tests/data/good_maps/*xml; do \
		nik2img.py $${FILE} /tmp/$$(basename $${FILE}).png; \
	done

.PHONY: install mapnik clean distclean reset uninstall test demo pep8 grind render

=== SConstruct ===
--- 
+++ 
@@ -42,7 +42,7 @@
 
 DEFAULT_CC = "cc"
 DEFAULT_CXX = "c++"
-DEFAULT_CXX11_CXXFLAGS = " -std=c++11 -DU_USING_ICU_NAMESPACE=0"
+DEFAULT_CXX11_CXXFLAGS = " -std=c++14 -DU_USING_ICU_NAMESPACE=0"
 DEFAULT_CXX11_LINKFLAGS = ""
 if sys.platform == 'darwin':
     # homebrew default
@@ -62,7 +62,7 @@
 SCONF_TEMP_DIR = '.sconf_temp'
 # auto-search directories for boost libs/headers
 BOOST_SEARCH_PREFIXES = ['/usr/local','/opt/local','/sw','/usr',]
-BOOST_MIN_VERSION = '1.47'
+BOOST_MIN_VERSION = '1.61'
 #CAIRO_MIN_VERSION = '1.8.0'
 
 HARFBUZZ_MIN_VERSION = (0, 9, 34)

=== debian/changelog ===
mapnik (3.1.0+ds-7ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:03:03 +0000

mapnik (3.1.0+ds-7ubuntu1) noble; urgency=medium

  * Use scons from the Debian package (for Python 3.12 support)
  * Cherry-pick SConstruct upstream changes for Scons >= 4.1.0

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 19 Mar 2024 16:40:34 +0100

mapnik (3.1.0+ds-7) unstable; urgency=medium

  * Add dpkg-dev (>= 1.22.5) to build dependencies for t64 changes.
    (closes: #1065294)

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 02 Mar 2024 13:14:12 +0100

mapnik (3.1.0+ds-6) unstable; urgency=medium

  * Replace pkg-config (build) dependency with pkgconf.
  * Move from experimental to unstable.
    (closes: #1062834)

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 28 Feb 2024 15:51:21 +0100

mapnik (3.1.0+ds-6~exp1) experimental; urgency=medium

  * Improve t64 changes to match team standards.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 05 Feb 2024 14:02:37 +0100

mapnik (3.1.0+ds-5.1~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Graham Inggs <ginggs@debian.org>  Sat, 03 Feb 2024 18:57:53 +0000

mapnik (3.1.0+ds-5) unstable; urgency=medium

  * Fix dh_auto_clean override.
    (closes: #1046672)
  * Use execute_after instead of override in rules file.
  * Enable Salsa CI.
  * Add patch to fix Boost 1.81 compatibility.
  * Add patches to fix Boost 1.83 compatibility.
    (closes: #1056024)

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 18 Dec 2023 11:10:31 +0100

mapnik (3.1.0+ds-4) unstable; urgency=medium

  * Bump Standards-Version to 4.6.2, no changes.
  * Update obsolete freetype (build) dependency.
  * Bump debhelper compat to 13.
  * Add patch to fix FTBFS with gcc-13.
    (closes: #1037768)
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 13 Jul 2023 19:41:22 +0200

mapnik (3.1.0+ds-3) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Bump Standards-Version to 4.6.1, no changes.
  * Update lintian overrides.
  * Add Rules-Requires-Root to control file.

  [ Angelos Tzotsos ]
  * Added proj patch.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 01 Dec 2022 12:26:27 +0100

mapnik (3.1.0+ds-2) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Update watch file for GitHub URL changes.
  * Bump Standards-Version to 4.6.0, no changes.
  * Bump debhelper compat to 12, changes:
    - Drop --list-missing from dh_install
    - Drop -V from dh_makeshlibs
  * Update lintian overrides.

  [ Jeremy Bicha ]
  * Cherry-pick patch to stop using deprecated py3 collections import.
    (closes: #1009438)

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 12 Apr 2022 21:55:10 +0200

mapnik (3.1.0+ds-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 11 Jan 2021 05:33:41 +0100

mapnik (3.1.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Rename library package for new minor version.
  * Drop explicit architecture list, see: #893188.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 08 Jan 2021 14:57:36 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Source: mapnik
-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: David Paleino <dapal@debian.org>,
            Francesco Paolo Lovergine <frankie@debian.org>,
            Jérémy Lal <kapouer@melix.org>,
            Bas Couwenberg <sebastic@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 10~),
+Build-Depends: debhelper-compat (= 13),
+               dpkg-dev (>= 1.22.5),
                libboost-filesystem-dev,
                libboost-program-options-dev,
                libboost-regex-dev,
@@ -14,7 +16,7 @@
                libboost-thread-dev,
                libcairo-dev,
                libcurl4-gnutls-dev | libcurl-ssl-dev,
-               libfreetype6-dev,
+               libfreetype-dev,
                libgdal-dev,
                libharfbuzz-dev,
                libicu-dev,
@@ -28,20 +30,25 @@
                libtool,
                libwebp-dev,
                libxml2-dev,
-               pkg-config,
+               pkgconf,
                python3,
+               scons,
                zlib1g-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/mapnik
 Vcs-Git: https://salsa.debian.org/debian-gis-team/mapnik.git
 Homepage: http://www.mapnik.org/
+Rules-Requires-Root: no
 
-Package: libmapnik3.0
-Architecture: any-amd64 i386 arm64 armel armhf powerpc ppc64el s390x alpha hppa m68k powerpcspe ppc64 sh4 sparc64 x32
+Package: libmapnik3.1t64
+Architecture: any
 Depends: fonts-dejavu,
          ${shlibs:Depends},
          ${misc:Depends}
 Suggests: postgis
+Provides: ${t64:Provides}
+Breaks: libmapnik3.1 (<< ${source:Version})
+Replaces: libmapnik3.1
 Description: C++ toolkit for developing GIS applications (libraries)
  Mapnik is an OpenSource C++ toolkit for developing GIS
  (Geographic Information Systems) applications. At the core is a C++
@@ -55,9 +62,9 @@
  This package contains the shared library and input plugins.
 
 Package: libmapnik-dev
-Architecture: any-amd64 i386 arm64 armel armhf powerpc ppc64el s390x alpha hppa m68k powerpcspe ppc64 sh4 sparc64 x32
+Architecture: any
 Section: libdevel
-Depends: libmapnik3.0 (= ${binary:Version}),
+Depends: libmapnik3.1t64 (= ${binary:Version}),
          libboost-filesystem-dev,
          libboost-program-options-dev,
          libboost-regex-dev,
@@ -66,7 +73,7 @@
          libc6-dev | libc-dev,
          libcairo2-dev,
          libcurl4-gnutls-dev | libcurl-ssl-dev,
-         libfreetype6-dev,
+         libfreetype-dev,
          libgdal-dev,
          libharfbuzz-dev,
          libicu-dev,
@@ -79,7 +86,7 @@
          libtiff-dev,
          libwebp-dev,
          libxml2-dev,
-         pkg-config,
+         pkgconf,
          zlib1g-dev,
          ${misc:Depends}
 Recommends: mapnik-doc
@@ -99,7 +106,7 @@
  build utilities.
 
 Package: mapnik-utils
-Architecture: any-amd64 i386 arm64 armel armhf powerpc ppc64el s390x alpha hppa m68k powerpcspe ppc64 sh4 sparc64 x32
+Architecture: any
 Section: utils
 Depends: ${shlibs:Depends},
          ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

NJOBS := -j1
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
NJOBS := -j$(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# Disable parallel builds for problematic architectures
NO_PARALLEL_ARCHS = arm64 armel armhf alpha hurd-i386 kfreebsd-i386 kfreebsd-amd64

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	# From mapnik (3.0.8+ds-1ubuntu1):
	# The amd64 buildds are castrated to 4G RAM and 4G swap,
	# the ppc64el buildds to 12G RAM and 4G swap.
	NO_PARALLEL_ARCHS += amd64 ppc64el
endif

ifneq (,$(filter $(DEB_BUILD_ARCH),$(NO_PARALLEL_ARCHS)))
	NJOBS = -j1
endif

# scons flags
SCONS = /usr/bin/scons
SCONS_FLAGS := $(NJOBS)
# -O2
SCONS_FLAGS += OPTIMIZATION=2
SCONS_FLAGS += FULL_LIB_PATH=False
SCONS_FLAGS += INPUT_PLUGINS=csv,gdal,geojson,ogr,pgraster,postgis,raster,shape,sqlite,topojson
SCONS_FLAGS += PROJ_INCLUDES=/usr/include PROJ_LIBS=/usr/lib
SCONS_FLAGS += SYSTEM_FONTS=/usr/share/fonts
SCONS_FLAGS += XMLPARSER=libxml2
SCONS_FLAGS += DEMO=False
SCONS_FLAGS += CPP_TESTS=False
SCONS_FLAGS += PREFIX=/usr LIB_DIR_NAME=/mapnik/3.1
SCONS_FLAGS += CUSTOM_CXXFLAGS="$(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS) -g0"
SCONS_FLAGS += CUSTOM_CFLAGS="$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS) -g0"
SCONS_FLAGS += CUSTOM_LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS) -g0"

%:
	dh $@

execute_before_dh_auto_clean:
	rm -rf build-python
	rm -rf debian/stamps
	find scons -type f -name "*.pyc" -delete
	find scons -type d -name "__pycache__" -delete

override_dh_auto_configure: debian/stamps/configure-python
debian/stamps/configure-python:
	-mkdir build-python
	-mkdir debian/stamps
	cp -r demo deps fonts include plugins src test utils SConstruct build-python
	touch $@
	$(SCONS) -C build-python configure \
		$(SCONS_FLAGS) \
		CCFLAGS="$(CFLAGS)" \
		DESTDIR=$(CURDIR)/debian/tmp

override_dh_auto_build:	debian/stamps/build-python
debian/stamps/build-python:
	$(SCONS) $(NJOBS) -C build-python

override_dh_auto_test: debian/stamps/test-python
debian/stamps/test-python:
	# nothing yet

override_dh_auto_install: debian/stamps/install-python
debian/stamps/install-python:
	$(SCONS) $(NJOBS) -C build-python install

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_prep:
	dh_prep -Xdebian/tmp

## mapnik 4.0.0+ds

=== debian/changelog ===
mapnik (4.0.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 17 Jun 2024 05:49:31 +0200

mapnik (4.0.0~rc4+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 14 Jun 2024 19:31:04 +0200

mapnik (4.0.0~rc3+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 14 Jun 2024 06:15:45 +0200

mapnik (4.0.0~rc2+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop dpkg-dev build dependency.
  * Drop include.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 10 Jun 2024 20:24:18 +0200

mapnik (4.0.0~rc1+ds-1~exp3) experimental; urgency=medium

  * Use /usr/share/fonts for pkg-config fonts_dir variable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 16 Apr 2024 15:49:40 +0200

mapnik (4.0.0~rc1+ds-1~exp2) experimental; urgency=medium

  * Don't include pre-releases in version specific plugin path.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 16 Apr 2024 14:52:59 +0200

mapnik (4.0.0~rc1+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Add patch to fix FTBFS with Python 3.12.
    (closes: #1067163)
  * Exclude scons subdirectory from repacked upstream tarball.
  * Update copyright file.
  * Drop patches, fixed/included upstream.
  * Use cmake buildsystem instead of scons.
  * Rename library package for SONAME bump.
  * Add patch to install headers under /usr/include/mapnik.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 16 Apr 2024 12:39:31 +0200

mapnik (3.1.0+ds-8) unstable; urgency=medium

  * Add patch to fix FTBFS with Python 3.12.
    (closes: #1067163)
  * Add patch to fix FTBFS with libxml2 2.12.
    (closes: #1073332)

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 16 Jun 2024 16:39:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: mapnik
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: David Paleino <dapal@debian.org>,
            Francesco Paolo Lovergine <frankie@debian.org>,
            Jérémy Lal <kapouer@melix.org>,
            Bas Couwenberg <sebastic@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
-               dpkg-dev (>= 1.22.5),
+Build-Depends: cmake,
+               debhelper-compat (= 13),
                libboost-filesystem-dev,
                libboost-program-options-dev,
                libboost-regex-dev,
@@ -21,18 +20,19 @@
                libharfbuzz-dev,
                libicu-dev,
                libjpeg-dev,
+               libmapbox-geometry-dev,
+               libmapbox-polylabel-dev,
                libmapbox-variant-dev (>= 1.1.5),
                libpng-dev,
                libpq-dev,
                libproj-dev,
+               libprotozero-dev,
                libsqlite3-dev,
                libtiff-dev,
                libtool,
                libwebp-dev,
                libxml2-dev,
                pkgconf,
-               python3,
-               scons,
                zlib1g-dev
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/mapnik
@@ -40,15 +40,12 @@
 Homepage: http://www.mapnik.org/
 Rules-Requires-Root: no
 
-Package: libmapnik3.1t64
+Package: libmapnik4.0.0
 Architecture: any
 Depends: fonts-dejavu,
          ${shlibs:Depends},
          ${misc:Depends}
 Suggests: postgis
-Provides: ${t64:Provides}
-Breaks: libmapnik3.1 (<< ${source:Version})
-Replaces: libmapnik3.1
 Description: C++ toolkit for developing GIS applications (libraries)
  Mapnik is an OpenSource C++ toolkit for developing GIS
  (Geographic Information Systems) applications. At the core is a C++
@@ -64,7 +61,7 @@
 Package: libmapnik-dev
 Architecture: any
 Section: libdevel
-Depends: libmapnik3.1t64 (= ${binary:Version}),
+Depends: libmapnik4.0.0 (= ${binary:Version}),
          libboost-filesystem-dev,
          libboost-program-options-dev,
          libboost-regex-dev,
@@ -78,10 +75,13 @@
          libharfbuzz-dev,
          libicu-dev,
          libjpeg-dev,
+         libmapbox-geometry-dev,
+         libmapbox-polylabel-dev,
          libmapbox-variant-dev (>= 1.1.5),
          libpng-dev,
          libpq-dev,
          libproj-dev,
+         libprotozero-dev,
          libsqlite3-dev,
          libtiff-dev,
          libwebp-dev,
@@ -90,8 +90,6 @@
          zlib1g-dev,
          ${misc:Depends}
 Recommends: mapnik-doc
-Breaks: libmapnik2-dev (<< 2.2.0+ds1-1~)
-Replaces: libmapnik2-dev (<< 2.2.0+ds1-1~)
 Description: C++ toolkit for developing GIS applications (devel)
  Mapnik is an OpenSource C++ toolkit for developing GIS
  (Geographic Information Systems) applications. At the core is a C++
